// Silly little robot

#include <libplayerc++/playerc++.h>
#include <iostream>
#include <math.h>
#include "args.h"

#define _USE_MATH_DEFINES
#define DEBUG 1

double fix_angle(double angle) {
	if (angle < -M_PI) {
		while (angle < -M_PI) angle+=2*M_PI;
	}
	if (angle > M_PI) {
		while (angle > M_PI) angle-=2*M_PI;
	}
	
	return angle;
}


int main(int argc, char** argv)
{
	using namespace PlayerCc;
	using namespace std;
	
	parse_args(argc,argv);

	// we throw exceptions on creation if we fail
	try
	{
	 PlayerClient robot(gHostname, gPort);
	 Position2dProxy pp(&robot, gIndex);

	 pp.SetMotorEnable (true);

	 player_pose2d_t goal = {6, 3, DTOR(0)};

	
	 // go into read-think-act loop
	 while (1) {
			robot.Read();
			player_pose2d_t goalPos = goal;			
			double velocity = 3;
			double angular_velocity = 1;

	  		// If the robot has approximately reached the position
			if (abs(pp.GetXPos()-goalPos.px)<.2 
				&& abs(pp.GetYPos()-goalPos.py)<.2 
				&& ( fix_angle(abs(pp.GetYaw()-goalPos.pa))<.2)) {
			  std::cout << "Yippee!!" << std::endl;
			}
			
			// write commands to robot
	  		pp.SetSpeed(velocity, angular_velocity);
		}
	}
	catch (PlayerCc::PlayerError e)
	{
	 std::cerr << e << std::endl;
	 return -1;
	}
}
